// Proizvodjac.java - Klasa proizvodjaca.

package skladiste;
import  usluge.Polje;

public class Proizvodjac extends Thread {

  private static int ukId = 0;    // Poslednje korisceni identifikator.
  private int id = ++ukId;        // Identifikator proizvodjaca.
  private Skladiste skladiste;    // Pridruzeno skladiste.
  private int minVreme, maxVreme; // Najkrace i najduze vreme proizvodnje.
  private int broj;               // Poslednje proizvedeni podatak.
  private Polje polje;            // Polje za prikaz stanja proizvodjaca.

  public Proizvodjac                            // Inicijalizacija.
    (Skladiste sklad, int minVr, int maxVr, Polje p) { 
    minVreme = minVr; maxVreme = maxVr; 
    skladiste = sklad; polje = p;
  }
  
  public Proizvodjac (Skladiste sklad, int minVr, int maxVr) 
    { this (sklad, minVr, maxVr, null); }
  
  public Proizvodjac (Skladiste sklad) 
    { this (sklad, 1000, 2000); }
  
  public void run () {                          // Telo niti.
    while (true) {
      long vreme = (long)(minVreme + Math.random() * (maxVreme-minVreme));
      try { Thread.sleep (vreme); } catch (InterruptedException g) {}
      int vredn = id*1000 + ++broj; 
      skladiste.stavi (vredn);
      if (polje != null) polje.pisi (vredn);
    }
  }
}